.nolist
COMMENT @ inspired by http://www.masm32.com/board/index.php?topic=6181.15

InstrCi knows three search modes, passed with the fourth para:

StartPos equ 1

1.	invoke InstrCi, StartPos, addr Mainstr, addr SubstrxCi, 0
	start at pos 1, search case-sensitive for SubstrxCi in Mainstr

2.	invoke InstrCi, StartPos, addr Mainstr, addr SubstrxCi, 1
	start at pos 1, search case-insensitive for SubstrxCi in Mainstr

3.	invoke InstrCi, StartPos, addr Mainstr, addr SubstrxCi, 2
	start at pos 1, search for SubstrxCi in Mainstr, ignore case of first character

The first para indicates the start position. Use 1 for a standard search.
If this para is 0, then InstrCi continues directly after the last match. @

    .686
    .MODEL FLAT,STDCALL
    OPTION CASEMAP:NONE
  
    include \masm32\include\windows.inc
    include \masm32\macros\timers.asm      
    include \masm32\macros\macros.asm    
    include \masm32\include\kernel32.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\msvcrt.inc
    include \masm32\include\shlwapi.inc

    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\msvcrt.lib
    includelib \masm32\lib\shlwapi.lib

    InStringL	PROTO :DWORD, :DWORD
    InstrCi	PROTO :DWORD, :DWORD, :DWORD, :DWORD
    finstr	PROTO :DWORD, :DWORD, :DWORD

; 

.data
Mainstr	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot "
	db "and whether pigs have wongs "
	db "The time has come the walrus said to speak of many things, of birds and bugs and ceiling wax, of cabbages and kings. And if the sea is boiling hot "
	db "and whether pigs have wings and fly", 0

Substrx	db "wings and fly", 0	; for the first three algos, crt_strstr, finstr and InStringL
SubstrxCi	db "Wings AND fly", 0	; for testing the case-insensitive algos InstrCi and StrStrI

cl1 dd 0
cl2 dd 0
cl3 dd 0
cl4 dd 0
cl5 dd 0

.data?
res1	dd ?
res2	dd ?
res3	dd ?
res4	dd ?
res5	dd ?
CurPos	dd ?

.code
start:

; 

NumLoops EQU 10000

  REPEAT 8

    LOOP_COUNT EQU NumLoops 
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke crt_strstr,addr Mainstr,addr Substrx
    mov res1, eax
    counter_end
    add cl1, eax
    print str$(eax)," timing crt_strstr",13,10

    LOOP_COUNT EQU NumLoops 
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke finstr,0,addr Mainstr,addr Substrx
    mov res2, eax
    counter_end
    add cl2, eax
    print str$(eax)," timing finstr",13,10

    LOOP_COUNT EQU NumLoops 
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke InStringL,addr Mainstr,addr Substrx
    mov res3, eax
    counter_end
    add cl3, eax
    print str$(eax)," timing InStringL",13,10

    LOOP_COUNT EQU NumLoops 
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke InstrCi, 1, addr Mainstr, addr SubstrxCi, 1		; 1=case-insensitive, 2=intelligent ci
    mov res4, eax
    counter_end
    add cl4, eax
    print str$(eax)," timing InstrCi",13,10

    LOOP_COUNT EQU NumLoops
    counter_begin LOOP_COUNT/100, HIGH_PRIORITY_CLASS
    invoke StrStrI, addr Mainstr, addr SubstrxCi
    mov res5, eax
    counter_end
    add cl5, eax
    print str$(eax)," timing StrStrI", 13,10, 13,10
   
  ENDM

    shr cl1, 3
    shr cl2, 3
    shr cl3, 3
    shr cl4, 3
    shr cl5, 3

    print "----------------------",13,10
    print str$(cl1)," average crt_strstr",9, "res="
    print str$(res1),13,10
    print str$(cl2)," average finstr",9, "res="
    print str$(res2),13,10
    print str$(cl3)," average InStringL",9, "res="
    print str$(res3),13,10
    print str$(cl4)," average InstrCi",9, "res="
    print str$(res4),13,10
    print str$(cl5)," average StrStrI",9, "res="
    print str$(res5),13,10
    print "----------------------",13,10

    inkey

invoke ExitProcess, 0

; 
OPTION PROLOGUE:NONE			; turn it off
OPTION EPILOGUE:NONE			;
align 16						;
InStringL	proc lpSource:DWORD, lpPattern:DWORD
	mov		eax, [esp+1*4]		; eax-> lpSource
    mov		edx, [esp+2*4]		; edx->lpPattern
    movzx	ecx, byte ptr [edx] ; ecx->the 1st byte of substring
	mov		[esp+2*4], esi		; saving register esi
    imul	ecx, 1010101h       ; ecx=77 77 77 77h  ; 77h -> ASCII code of "w"
	mov		[esp+1*4], ebx		; saving register ebx
	lea		esi, [edx+1]		; esi->lp Pattern +1
BytesScan:						;
	mov		edx, ecx			; edx=77 77 77 77h  ; 77h -> ASCII code of "w"
	xor		ebx, ebx			;
@@:								;
	xor		ecx, [eax]			;
	add		eax, 4				;              
	add		ecx, 0FEFEFEFFh		;   
    test	ecx, 080808080h		;   
	mov		ecx, edx			; edx=77 77 77 77h  ; 77h -> ASCII code of "w"
  	je		@b					; 
								;
    cmp		[eax-4], dl			; dl ->1st byte of pattern
    lea		eax, [eax-3]	
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]	
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]
	jne		@b
@@:								; CMP rest  of strings
	add		bl,	 [esi]
	je		@found	
	sub		bl,	 [eax]
	jne		BytesScan
	add		bl,	 [esi+1]
	je		@found	
	sub		bl,	 [eax+1]
	jne		BytesScan
	add		bl,	 [esi+2]
	je		@found	
	sub		bl,	 [eax+2]
	jne		BytesScan
	add		bl,	 [esi+3]
	je		@found	
	sub		bl,	 [eax+3]
	jne		BytesScan	
	add		bl,	 [esi+4]
	je		@found	
	sub		bl,	 [eax+4]
	jne		BytesScan
	add		bl,	 [esi+5]
	je		@found	
	sub		bl,	 [eax+5]
	jne		BytesScan
	add		bl,	 [esi+6]
	je		@found	
	sub		bl,	 [eax+6]
	jne		BytesScan
	add		bl,	 [esi+7]
	je		@found	
	sub		bl,	 [eax+7]
	jne		BytesScan
	add		bl,	 [esi+8]
	je		@found	
	sub		bl,	 [eax+8]
	jne		BytesScan
	mov		edx, 8
@@:	
	add		bl,	 [esi+edx+1]
	je		@found	
	sub		bl,	 [eax+edx+1]
	jne		BytesScan
	add		bl,	 [esi+edx+2]
	je		@found	
	sub		bl,	 [eax+edx+2]
	jne		BytesScan
	add		bl,	 [esi+edx+3]
	je		@found	
	sub		bl,	 [eax+edx+3]
	jne		BytesScan
	add		bl,	 [esi+edx+4]
	je		@found	
	sub		bl,	 [eax+edx+4]
	jne		BytesScan
	add		edx, 4
	jne		@b
@found:	
	mov		ebx, [esp+1*4]	 
	cmp		eax, esi		
	mov		esi, [esp+2*4]	 
	sbb		ecx, ecx
	mov		edx, [esp]	 
	add		eax,  -1		
	add		esp, 3*4 
	and		eax, ecx		;eax-> address of 1st occurrence or 0->Not found   
	jmp		edx				;
InStringL	endp			;
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

finstr proc spos:DWORD,psrc:DWORD,patn:DWORD

    .data?
      align 16
      _ebx dd ?
      _esi dd ?
      _edi dd ?
      _ebp dd ?
    .code

    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp

    mov ebp, 1
    mov edi, [esp+12]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st patn byte in AL
    mov esi, [esp+8]                ; psrc
    add esi, [esp+4]                ; spos
    sub esi, ebp

; --------------------

  align 16
  scanloop:
  REPEAT 15
    add esi, ebp
    movzx edx, BYTE PTR [esi]
    cmp eax, edx
    je prematch
    test edx, edx                   ; test for source terminator
    jz no_match
  ENDM

    add esi, ebp
    movzx edx, BYTE PTR [esi]
    cmp eax, edx
    je prematch
    test edx, edx                   ; test for source terminator
    jnz scanloop
    jmp no_match

; --------------------

  align 16
  prematch:
    xor ebx, ebx

; --------------------

  matchloop:
  REPEAT 7
    add ebx, ebp
    movzx ecx, BYTE PTR [esi+ebx]
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match
    cmp ecx, edx
    jne scanloop
  ENDM

    add ebx, ebp
    movzx ecx, BYTE PTR [esi+ebx]
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match
    cmp ecx, edx
    jne scanloop
    jmp matchloop

; --------------------

  match:
    sub esi, [esp+8]                ; psrc
    mov eax, esi
    jmp cleanup

  no_match:
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 12

finstr endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; ##############################################
align 16

InstrCi proc uses edi esi ebx StartPos:DWORD, lpSource:DWORD, lpPattern:DWORD, sMode:DWORD
  mov eax, lpSource
  .if StartPos			; e.g. invoke InstrCi, 1, addr Mainstr, addr SubstrxCi, 0 means
	push StartPos	; start at pos1, find Substr in Mainstr, case-sensitive
	pop CurPos		; invoke InstrCi, 0, ... means continue with Current Position
  .endif
  add eax, CurPos		; start with current position or StartPos
  xor ebx, ebx			; default mode: case-sensitive search
  .if sMode
	add ebx, 20h	; intellicase: finds "test" and "Test" but not "TEST" in "This is a Test"
	.if sMode==1	; lowercase bit mask for finding "TEST" in "This is a Test"
		mov ebx, 20202020h
	.endif
  .endif

NoSucc:
  mov edx, lpPattern	; address of pattern
  mov cx, [edx+2]		; test pattern length after NoSucc:
  mov edx, [edx]		; edx has 4 bytes of pattern, e.g. test
  or edx, ebx			; make first byte or first 4 bytes of pattern lowercase, if sMode is set

  .if cl && ch			; pattern length >=4?
@@:	mov ecx, [eax]
	test cl, cl		; end of source string?
	jz SrcEnd
	or ecx, ebx		; make source lowercase
	add eax, 1		; (inc eax would cost around 5%)
	cmp ecx, edx	; compare 4 bytes of source with pattern (faster than 2 bytes cmp)
	jne @B

  .else
@@:	mov cx, [eax]
	test cl, cl		; source end?
	jz SrcEnd
	or ecx, ebx		; make source lowercase
	add eax, 1		; (inc eax would cost around 5%)
	cmp cx, dx		; compare 2 bytes of source with pattern (slower than 4 bytes cmp)
	jne @B
  .endif

  cmp ebx, 20h	; intellisearch? if not, go for iciAll
  mov esi, lpPattern
  mov edi, eax		; current pos in source string
  jne iciAll
	inc esi		; changes flag, so it must come after the jne
	repe cmpsb
	jmp iciAny	; go and check if end of pattern was reached

iciAll:
	inc esi		; changes flag, so it must come after the jne
	push eax	; save current pos
@@:	lodsb		; mov al, [esi], esi++
	or al, bl		; make lowercase
	mov cl, [edi]
	inc edi		; add edi, 1 is faster but this is not an inner loop
	or cl, bl		; make lowercase
	cmp al, cl	; if equal, go for the next char
	je @B
	pop eax		; current pos in source string restored

iciAny:
  mov ecx, [esi-1]	; check for end of pattern - if yes, we are done
  or cl, cl			; get the flag
  jz @F			; if not zero, we still have to test a...
  mov ecx, [esi-2]		; ... rare case: pattern and source finish on the same byte
  or cl, cl
  jnz NoSucc

@@:
  mov ecx, eax
  sub ecx, lpSource	; ecx has the relative pos, if needed
  mov CurPos, ecx	
  dec eax			; we return in eax the pos in lpSource where the pattern was found
  ret

SrcEnd:
  xor eax, eax		; no match found, sorry
  ret
InstrCi endp

; ##############################################

end start
OPT_SUSY	CONSOLE
OPT_DelTmp	0
